package NTLSystem.support;

import com.sun.java.swing.*;

/**
 * An extension of JTextArea which automagically scrolls to the bottom
 * when text is appended.
 * <P>
 * $Id: AppendScrollingTextArea.java,v 1.1 1998/09/04 02:53:42 jsled Exp $<BR>
 * Last Editor: $Author: jsled $
 *
 * @author    Joshua Sled [jsled@icsi.berkeley.edu]
 * @see       JTextArea
 * @version   $Revision: 1.1 $
 **/
public class AppendScrollingTextArea
    extends JTextArea
{

    public AppendScrollingTextArea(int rows, int cols)
    {
	super(rows, cols);
    }

    public void append(String s)
    {
	super.append( s );
	setCaretPosition( getDocument().getLength() );
    }
}
