package NTLSystem.support;

import java.awt.*;
import java.awt.event.*;

/**
 * A WindowAdapter to wait for the window to close, then return.
 * <P>
 * $Id: WindowWaiter.java,v 1.1 1998/06/20 01:08:30 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 *
 * @author    Joshua Sled [jsled@icsi.berkeley.edu]
 * @version   $Revision: 1.1 $
 **/
public class WindowWaiter extends WindowAdapter {
  private boolean done = false;
  public WindowWaiter()
  {
    super();
  }

  public synchronized void WaitUntilDone()
  {
    try {
      while (done == false) {
	this.wait();
      }
    } catch (InterruptedException ie) {
      // Do nothing
    } // end try-catch
  }

  public synchronized void windowClosing(WindowEvent we)
  {
    done = true;
    this.notifyAll();
  }
}
