package NTLSystem.verblearn;

import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import NTLSystem.support.*;
import NTLSystem.*;

/**
 * A LabelList contains all words/morphemes (?) in labels used with 
 *   the ScenarioSet, kept in a StringSortedHashtable (by language)
 *   of (alphabetical) vectors.
 * <P>
 * $Id: LabelList.java,v 1.1 1998/07/28 23:58:06 nchang Exp $<BR>
 * Last editor: $Author: nchang $
 *
 * @author    Nancy Chang [nchang@icsi.berkeley.edu]
 * @version   $Revision: 1.1 $
 **/

// WAIT we don't even need this as a class anymore -- use general.
class LabelChoices extends StringSortedHashtable
{  
  // {{{ ATTRIBUTES
  /** Hashtable of word-vectors.  **/  
  Hashtable labels;

  // {{{ CONSTRUCTORS

  /**
   * Basic constructor for a LabelList.
   **/
  LabelList() {
    labels = new Hashtable();
  }  

  // }}} end constructors

  // {{{ METHODS

  /**
   * add label to label list for language, in alphabetical order.
   * called from VerbComplex creation routine, or from labeling
   * returns true if label added (false if already there or failed)     
   *
   * @param     id The name of the Scenario to put in the ScenarioSet.
   **/
  public boolean addLabel(String language, String label) {

    add = false;
    if (labels == null) {
      System.out.println("Labellist null at this slot");
      return false;
    }
    if (labels.contains(l)) {
      return false; // no need to add
    }

    // else find alphabetical place and insert
    int i = 0;
    while (i < labels.size()) {
      // new string earlier alphabetically
      if (l.compareTo((String)labels.elementAt(i)) < 1) {
	add = true;
	break;
      }
      i++;
    } // end while
    index = i; // either where it stopped, or end of list (size)
    labels.insertElementAt(l, i); 
    //    System.out.println("adding " + l + " at index " + i);
    return true;
  }
  
  public Enumeration getLabelList() { return labels.elements(); }
  public int index() { return index; }
  public boolean addLast() { return add; }
}

