package NTLSystem.verblearn;

import java.io.*;
import java.util.*;
import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import NTLSystem.support.*;


///////////////////////////////////////////////////////////////////////
// Main Panel
  
class MainPanel extends Panel {

  MultiLineLabel label;
  Picture jackPict;

  MainPanel() {
    setLayout(new GridBagLayout());
    // HACK: For now, since we want the image/ directory to be part
    // of the "code" area and not the "data" area, we temporarily
    // assign a different base directory to the DataSource to get the
    // startup screen's image:
    String oldBase = null;
    if (VerbLearn.isApplication()) {
      oldBase = DataSource.getBase();
      DataSource.setUseFiles(VerbLearn.CODE_BASE_DIR);
    }
    try {
      jackPict = new Picture(DataSource.getLoadedImage("image/sample.jpg",
						       this));
    }
    catch (Exception e) {
      System.err.println("MainPanel exception loading image: " +
			 e.getMessage());
    }
    if (VerbLearn.isApplication()) {
      DataSource.setUseFiles(oldBase);
    }
    Constrain.add(this, jackPict, 0, 0, 1, 1, 20, 20, 30, 20);
    label = new MultiLineLabel("Welcome to VerbLearn\n \n" +
			       "Click on a tab to proceed.\n",
			       MultiLineLabel.CENTER);
    label.setFont(new Font("Helvetica", Font.PLAIN, 24));
    label.setForeground(new Color(150, 0, 0));
    Constrain.add(this, label, 0, 1, 1, 1, 30, 20, 20, 20);
    if (!VerbLearn.isApplication()) {
      MultiLineLabel warn = new MultiLineLabel(
    "Note: Since you're running the system as an applet, you \n" +
   "may not run the Jack animator, restricting your use of the \n" +
   "Generate and Obey panels.  Nor may you save any files.\n" +
   "Also, popup windows don't work correctly due to a Netscape bug.",
				       MultiLineLabel.CENTER);
      Constrain.add(this, warn, 0, 2, 1, 1, 20, 20, 50, 20);
    }
  }
}
