package NTLSystem.verblearn;

import java.io.*;
import java.util.*;
import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import NTLSystem.support.*;


///////////////////////////////////////////////////////////////////////
// Obeying testing Panel

class ObeyPanel extends Panel {

  private static final String INITIAL_TEXT = "Obey test log window\n\n";

  private Label title;
  private LangLabel langLabel;
  private Panel west, center, east;
  private Label cgLabel;
  private CheckboxGroup cg;
  private Checkbox all, selected, movie;
  private Label slLabel;
  private ScenarioList scenarioList;
  private Button doIt;
  private CommandEntryGrid commandEntryGrid;
  private ScrollingTextArea log;
  private Button clear, save;

  ObeyPanel() {
    setLayout(new GridBagLayout());
    title = new Label("Command Obeying Testing Window");
    title.setFont(new Font("Helvetica", Font.BOLD, 18));
    Constrain.add(this, title, 0, 0, 3, 1, 10, 10, 20, 10);
    langLabel = new LangLabel();
    Constrain.add(this, langLabel, 0, 1, 3, 1, 10, 10, 10, 10);
    west = new Panel();
    west.setLayout(new GridBagLayout());
    cgLabel = new Label("Obey:");
    Constrain.add(west, cgLabel, 0, 0, 1, 1, 10, 10, 10, 10);
    cg = new CheckboxGroup();
    all = new Checkbox("All (eval by recognition)", cg, true);
    Constrain.add(west, all, 0, 1, 1, 1, GridBagConstraints.NONE,
		  GridBagConstraints.WEST, 3, 10, 3, 10);
    selected = new Checkbox("Selected (w/ more detail)", cg, false);
    Constrain.add(west, selected, 0, 2, 1, 1, GridBagConstraints.NONE,
		  GridBagConstraints.WEST, 3, 10, 3, 10);
    movie = new Checkbox("Selected (eval by movie)", cg, false);
    Constrain.add(west, movie, 0, 3, 1, 1, GridBagConstraints.NONE,
		  GridBagConstraints.WEST, 3, 10, 10, 10);
    Constrain.add(this, west, 0, 2, 1, 1, GridBagConstraints.BOTH,
		  GridBagConstraints.CENTER, 10, 10, 10, 10);
    doIt = new Button("Do It !");
    doIt.setFont(new Font("Helvetica", Font.PLAIN, 18));
    Constrain.add(west, doIt, 0, 4, 1, 1, 10, 10, 10, 10);
    center = new Panel();
    center.setLayout(new GridBagLayout());
    slLabel = new Label("Scenario List:");
    Constrain.add(center, slLabel, 0, 0, 1, 1, 10, 10, 10, 10);
    scenarioList = new ScenarioList(false, false, true);
    scenarioList.setEnabled(false);
    Constrain.add(center, scenarioList, 0, 1, 1, 1, GridBagConstraints.BOTH,
		  GridBagConstraints.CENTER, 10, 10, 10, 10);
    Constrain.add(this, center, 1, 2, 1, 1, GridBagConstraints.BOTH,
		  GridBagConstraints.CENTER, 10, 10, 10, 10);
    east = new Panel();
    east.setLayout(new GridBagLayout());
    commandEntryGrid = new CommandEntryGrid();
    commandEntryGrid.setEnabled(false);
    Constrain.add(east, commandEntryGrid, 0, 0, 1, 1, 
		  GridBagConstraints.BOTH, GridBagConstraints.CENTER, 
		  10, 10, 10, 10);
    Constrain.add(this, east, 2, 2, 1, 1, GridBagConstraints.BOTH,
		  GridBagConstraints.CENTER, 10, 10, 10, 10);
    // SET UP ANIMATION WINDOW HERE...
    Constrain.add(this, new Label("(Movie plays here)"),
		  0, 3, 1, 1, 10, 10, 10, 10);
    log = new ScrollingTextArea(INITIAL_TEXT, 20, 65);
    Constrain.add(this, log, 1, 3, 2, 1, 10, 10, 10, 10);
    clear = new Button("Clear Log");
    Constrain.add(this, clear, 0, 4, 1, 1, GridBagConstraints.NONE,
		  GridBagConstraints.WEST, 5, 10, 10, 10);
    save = new Button("Save Log...");
    Constrain.add(this, save, 2, 4, 1, 1, GridBagConstraints.NONE,
		  GridBagConstraints.EAST, 5, 10, 10, 10);
  }

  // Called whenever lexicon changes (e.g., by TrainPanel).
  public void rebuildCommandEntryGrid() { 
    commandEntryGrid.rebuild();
  }

  public boolean action(Event e, Object junk) {
    // SHOULD CATCH SCENARIO-SELECTION AND DISPLAY FIRST FRAME IF AVAIL.
    if (e.target == selected) {
      scenarioList.setEnabled(true);
      int[] selected = scenarioList.getSelectedIndexes();
      for (int i = 0; i < selected.length; i++) {
	scenarioList.deselect(selected[i]);
      }
      scenarioList.setMasks(false, false, true);
      commandEntryGrid.setEnabled(false);
      commandEntryGrid.clear();
      return true;
    }
    if (e.target == all) {
      scenarioList.setEnabled(false);
      int[] selected = scenarioList.getSelectedIndexes();
      for (int i = 0; i < selected.length; i++) {
	scenarioList.deselect(selected[i]);
      }
      commandEntryGrid.setEnabled(false);
      commandEntryGrid.clear();
      return true;
    }
    if (e.target == movie) {
      scenarioList.setEnabled(true);
      int[] selected = scenarioList.getSelectedIndexes();
      for (int i = 0; i < selected.length; i++) {
	scenarioList.deselect(selected[i]);
      }
      scenarioList.setMasks(true, true, false);
      commandEntryGrid.setEnabled(true);
      return true;
    }
    if (e.target == doIt) {
      obey();
      return true;
    }
    if (e.target == clear) {
      log.setText(INITIAL_TEXT);
      return true;
    } 
    if (e.target == save) {
      if (VerbLearn.isApplication()) {
	saveLog();
      }
      else {
	log.append("Sorry, applet version can't save files.\n");
      }
      return true;
    }
    return super.action(e, junk);
  }

  private void obey() {
    if (cg.getSelectedCheckbox() == movie && !VerbLearn.isApplication()) {
	log.append("Sorry, applet version can't run Jack.\n");
	return;
      }
    if (VerbLearn.context().params() == null) {
      log.append("You must choose a parameter file before obey testing.\n");
      return;
    }
    if (cg.getSelectedCheckbox() == all && 
	VerbLearn.context().dataset() == null) {
      log.append("You must choose a dataset before (automated) obey " +
		 "testing.\n");
      return;
    }
    if (VerbLearn.context().lexicon() == null) {
      log.append("You must choose or train a lexicon before obey testing.\n");
      return;
    }
    if (cg.getSelectedCheckbox() == movie && 
	scenarioList.getSelectedItem() == null) {
      log.append("You must choose a scenario before (movie-based) obey " +
		 "testing.\n");
      return;
    }
    String[] scArray = null;
    if (cg.getSelectedCheckbox() == selected) {
      scArray = scenarioList.getSelectedItems();
      if (scArray == null || scArray.length == 0) {
	log.append("You haven't chosen any scenarios to test!\n");
	return;
      }
    }
    if (cg.getSelectedCheckbox() == movie && 
	commandEntryGrid.getCommand().equals("")) {
      log.append("You must enter a command before (movie-based) obey " +
		 "testing.\n");
      return;
    }
    log.append("Beginning obey test.\n");
    if (cg.getSelectedCheckbox() == all || 
	cg.getSelectedCheckbox() == selected) {
      int numCorrect = 0;
      int numTested = 0;
      Enumeration scEnum;
      if (cg.getSelectedCheckbox() == selected) {
	Vector v = new Vector();
	for (int i = 0; i < scArray.length; i++) {
	  v.addElement(scArray[i]);
	}
	scEnum = v.elements();
      }
      else {
	scEnum = VerbLearn.context().dataset().obeyEnum();
      }
      while (scEnum.hasMoreElements()) {
	String scName = (String)scEnum.nextElement();
	Scenario sc = VerbLearn.context().scenarios().get(scName);

	// nc add to prevent crash!
	if (VerbLearn.context().scenarios().containsKey(scName)) {
	  if (sc.isLabelled()) {

	    // Derive linking f-struct from the command and world state:
	    Fstruct f1 = VerbLearn.context().lexicon()
	      .obey(sc.label(), sc.initialLink());
	    // Simulate execution by filling in any needed defaults:
	    Fstruct f2 = execute(f1, sc.initialLink());
	    // Pass it back through recognizer:
	    String actual = VerbLearn.context().lexicon().label(f2).toString();
	    log.append("Scenario " + sc.id() + ": command=" + sc.label() + 
		       ", output=" + actual);
	    numTested++;
	    if (actual.equals(sc.label().toString())) {
	      numCorrect++;
	    }
	    else {
	      log.append("    *ERROR*");
	    }
	    log.append("\n");
	    // Print out full word probability vector only if in "selected" mode:
	    if (cg.getSelectedCheckbox() == selected) {
	      log.append("Linking f-struct (pre-execution):\n\t" + 
			 f1.toString4());
	      log.append("Linking f-struct (post-execution):\n\t" + 
		       f2.toString4());
	      log.append(VerbLearn.context().lexicon()
			 .allSensePosteriors(f2));
	    }
	  }
	  else {
	    log.append("WARNING: scenario " + sc.id() + " is unlabelled.\n");
	  }
	}
	else {
	  log.append("WARNING: non-existing scenario" + scName +
		     " not in scenario set.\n");
	}
      }
      log.append("Correctly recognized " + numCorrect + " of " +
		 numTested + " obeyed commands");
      if (numTested > 0) {
	log.append(" (" +
		   ((int)((double)numCorrect / (double)numTested * 100)) + 
		   "%).\n");
      }
    }
    else {
      // Play a movie to allow evaluation
      String cmd = commandEntryGrid.getCommand();
      Scenario sc = VerbLearn.context().scenarios().get(
			 scenarioList.getSelectedItem());
      log.append("Command is " + cmd + " with initial state from scenario " + 
		 sc.id() + ".\n");
      Fstruct f = VerbLearn.context().lexicon().obey(
		    new VerbComplex(cmd), sc.initialLink());
      // WRITE f TO FILE, TELL JACK TO EXECUTE IT, THEN PLAY MOVIE
      log.append("Actual execution and movie playing not implemented yet.\n");
    }
    log.append("Obey test done.\n\n");
  }

  private Fstruct execute(Fstruct f1, Fstruct w) {
    Fstruct f2 = new Fstruct(f1);
    // Fill in needed defaults in f2:
    // TBD...
    return f2;
  }

  private void saveLog() {
    if (VerbLearn.context().langslot() != null) {
      String dirname = VerbLearn.DATA_BASE_DIR + "lang/" +
	VerbLearn.context().langslot() + "/output/";
      File f = new File(dirname);
      if (!f.exists()) {
	f.mkdirs();
      }
      FileDialog fd = new FileDialog(VerbLearn.frame(), 
				     "Save Obeying Test Log As...", 
				     FileDialog.SAVE);
      fd.setDirectory(dirname);
      fd.show();
      String fname = fd.getFile();
      if (fname != null) {
	String pathname = fd.getDirectory() + fname;
	try {
	  PrintWriter pw = new PrintWriter(new FileWriter(pathname));
	  pw.print(log.getText());
	  pw.close();
	  log.append("This log saved in file " + pathname + "\n");
	}
	catch (IOException e) {
	  log.append("Could not save this log in " + pathname + ": " + 
		     e.getMessage() + "\n");
	}
      }
    }
  }

}
